/*
 * Copyright 2010-2014 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License").
 * You may not use this file except in compliance with the License.
 * A copy of the License is located at
 * 
 *  http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed
 * on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
 * express or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */

/*
 * Do not modify this file. This file is generated from the rds-2014-10-31.normal.json service model.
 */
using System;
using System.Collections.Generic;
using System.Xml.Serialization;
using System.Text;
using System.IO;

using Amazon.Runtime;
using Amazon.Runtime.Internal;

namespace Amazon.RDS.Model
{
    /// <summary>
    /// Provides a list of DB cluster snapshots for the user as the result of a call to the
    /// <a>DescribeDBClusterSnapshots</a> action.
    /// </summary>
    public partial class DescribeDBClusterSnapshotsResponse : AmazonWebServiceResponse
    {
        private List<DBClusterSnapshot> _dbClusterSnapshots = new List<DBClusterSnapshot>();
        private string _marker;

        /// <summary>
        /// Gets and sets the property DBClusterSnapshots. 
        /// <para>
        ///  Provides a list of DB cluster snapshots for the user. 
        /// </para>
        /// </summary>
        public List<DBClusterSnapshot> DBClusterSnapshots
        {
            get { return this._dbClusterSnapshots; }
            set { this._dbClusterSnapshots = value; }
        }

        // Check to see if DBClusterSnapshots property is set
        internal bool IsSetDBClusterSnapshots()
        {
            return this._dbClusterSnapshots != null && this._dbClusterSnapshots.Count > 0; 
        }

        /// <summary>
        /// Gets and sets the property Marker. 
        /// <para>
        ///  An optional pagination token provided by a previous <a>DescribeDBClusterSnapshots</a>
        /// request. If this parameter is specified, the response includes only records beyond
        /// the marker, up to the value specified by <code>MaxRecords</code>. 
        /// </para>
        /// </summary>
        public string Marker
        {
            get { return this._marker; }
            set { this._marker = value; }
        }

        // Check to see if Marker property is set
        internal bool IsSetMarker()
        {
            return this._marker != null;
        }

    }
}